//
//  DPCachedImage.m
//  Currency
//
//  Created by Hjalti Jakobsson on 7.8.2010.
//  Copyright 2010 Hjalti Jakobsson. All rights reserved.
//

#import "DPCachedImage.h"
#import "NSString+Extensions.h"
#import "DPUtils.h"

@interface DPCachedImage()
+ (NSString*)cachedImage:(NSURL*)url;
+ (void)cacheImage:(NSData*)data withURL:(NSURL*)url;
@end

@implementation DPCachedImage

+ (id)cachedImageWithContentsOfURL:(NSURL*)url
{
	NSString *path = [DPCachedImage cachedImage:url];
	
	if(path)
		return [[[self alloc] initWithContentsOfFile:path] autorelease];
	
	NSData *data = [NSData dataWithContentsOfURL:url];
	
	[DPCachedImage cacheImage:data withURL:url];	
	
	return [[[self alloc] initWithData:data] autorelease];
}

+ (void)cacheImage:(NSData*)data withURL:(NSURL*)url
{
	NSString *urlMD5 = [[url absoluteString] md5Value];
	NSString *path = [[DPUtils documentsFolder] stringByAppendingPathComponent:urlMD5];
	
	[data writeToFile:path atomically:YES];
}

+ (NSString*)cachedImage:(NSURL*)url
{
	NSString *urlMD5 = [[url absoluteString] md5Value];
	
	NSFileManager *fm = [NSFileManager defaultManager];
	
	NSString *path = [[DPUtils documentsFolder] stringByAppendingPathComponent:urlMD5];
	
	if([fm fileExistsAtPath:path])
		return path;
	
	return nil;
}

@end
