// 
//  Currency.m
//  Currency
//
//  Created by Hjalti Jakobsson on 17.8.2010.
//  Copyright 2010 Hjalti Jakobsson. All rights reserved.
//

#import "Currency.h"

#import "Record.h"

@implementation Currency 

@dynamic iconURL;
@dynamic name;
@dynamic identifier;
@dynamic records;

- (Record*)latestRecord
{
	if([self.records count] > 0)
	{	
		NSSortDescriptor *sortDescriptor = [[NSSortDescriptor alloc] initWithKey:@"date" ascending:NO];	
		NSArray *allRecords = [[self.records allObjects] sortedArrayUsingDescriptors:[NSArray arrayWithObject:sortDescriptor]];
		[sortDescriptor release];
		
		return [allRecords objectAtIndex:0];
	}
	
	return nil;
}

- (float)lastBuyValue
{
	Record *record = [self latestRecord];
	
	if(record)
		return [record.buy floatValue];
	
	return 0;
}

@end
